/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//shnQ@ddoqnl(`sXRbSU)vO
//	FileName	EEPROM.c
//	Version		1.00
//	MCU		H8/3694
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2007/04/19	Ver1.00
//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2007

*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//CN[ht@C錾
*/
/* }CRCu */
#include <machine.h>

/* WbCu */
#include <stdio.h>
#include <string.h>

/* IWi */
#include "3694S.h"
#include "Main.h"
#include "EEPROM.h"
#include "SCI.h"


/*
/////////////////////////////////////////////////////////////////////////////////////////
//萔錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//^錾
*/
#define size 64
#define CS_BIT		0x01
#define SK_BIT		0x08
#define DI_BIT		0x04
#define DI_BITNO	2
#define DO_BIT		0x02
#define DO_BITNO	1
#define ST_SZ		1
#define OP_SZ		2
#if 0
/* 93c46 16bit */
#define EWEN_ADR	0x30
#define EWDS_ADR	0x00
#define ERAL_ADR	0x20
#define ADR_SZ		6
#define DAT_SZ		16
#else
/* 93c46 8bit */
#define EWEN_ADR	0x60
#define EWDS_ADR	0x00
#define ERAL_ADR	0x40
#define ADR_SZ		7
#define DAT_SZ		8
#endif

/*
/////////////////////////////////////////////////////////////////////////////////////////
//ϐ錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//}N錾
*/
#define ROM_PORT	IO.PDR5.BYTE


/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/
int Init_EEPROM ( void );

void ewen_rom(void);
void ewds_rom(void);
void read_rom( unsigned char adr, unsigned short *dat );
void write_rom( unsigned char adr, unsigned short dat );
void eral_rom(void);


/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/


/*
///////////////////////////////////////////////////////////////////////////////
//Init_EEPROM
//Ekdc
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Init_EEPROM ( void )
{
	/* ddoqnlp|[g */
	IO.PMR5.BYTE &= ~0x0f;
	IO.PCR5 = ( (IO.PCR5 & ~0xff) | 0x0d );
	return NOERROR;
}




void ewen_rom(void)
{
	int i;
	unsigned char buf[(ST_SZ + OP_SZ + ADR_SZ)];
	
	for(i=0; i<ST_SZ; i++){
		buf[i] = 1;
	}
	for(i=0; i<OP_SZ; i++){
		buf[(i+ST_SZ)] = ((0 >> (OP_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<ADR_SZ; i++){
		buf[(i+ST_SZ+OP_SZ)] = ((EWEN_ADR >> (ADR_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		buf[i] = (buf[i] << DI_BITNO);
	}
	ROM_PORT = ROM_PORT | CS_BIT;				/*CS:H*/
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		ROM_PORT = ROM_PORT | buf[i];			/*DI:H*/
		ROM_PORT = ROM_PORT | SK_BIT;			/*SK:H*/
		ROM_PORT = ROM_PORT & ~DI_BIT;		/*DI:L*/
		ROM_PORT = ROM_PORT & ~SK_BIT;		/*SK:L*/
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			/*CS:L*/
}
void ewds_rom(void)
{
	int i;
	unsigned char buf[(ST_SZ + OP_SZ + ADR_SZ)];
	
	for(i=0; i<ST_SZ; i++){
		buf[i] = 1;
	}
	for(i=0; i<OP_SZ; i++){
		buf[(i+ST_SZ)] = ((0 >> (OP_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<ADR_SZ; i++){
		buf[(i+ST_SZ+OP_SZ)] = ((EWDS_ADR >> (ADR_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		buf[i] = (buf[i] << DI_BITNO);
	}
	ROM_PORT = ROM_PORT | CS_BIT;				/*CS:H*/
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		ROM_PORT = ROM_PORT | buf[i];			/*DI:H*/
		ROM_PORT = ROM_PORT | SK_BIT;			/*SK:H*/
		ROM_PORT = ROM_PORT & ~DI_BIT;		/*DI:L*/
		ROM_PORT = ROM_PORT & ~SK_BIT;		/*SK:L*/
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			/*CS:L*/
}
void read_rom( unsigned char adr, unsigned short *dat )
{
	int i;
	unsigned char buf[(ST_SZ + OP_SZ + ADR_SZ)];
	
	for(i=0; i<ST_SZ; i++){
		buf[i] = 1;
	}
	for(i=0; i<OP_SZ; i++){
		buf[(i+ST_SZ)] = ((2 >> (OP_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<ADR_SZ; i++){
		buf[(i+ST_SZ+OP_SZ)] = ((adr >> (ADR_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		buf[i] = (buf[i] << DI_BITNO);
	}
	ROM_PORT = ROM_PORT | CS_BIT;				/*CS:H*/
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		ROM_PORT = ROM_PORT | buf[i];			/*DI:H*/
		ROM_PORT = ROM_PORT | SK_BIT;			/*SK:H*/
		ROM_PORT = ROM_PORT & ~DI_BIT;		/*DI:L*/
		ROM_PORT = ROM_PORT & ~SK_BIT;		/*SK:L*/
	}
	for(i=0; i<DAT_SZ; i++){
		ROM_PORT = ROM_PORT | SK_BIT;			/*SK:H*/
		buf[i] = ROM_PORT; 
		ROM_PORT = ROM_PORT & ~SK_BIT;		/*SK:L*/
	}
	*dat = 0;
	for(i=0; i<DAT_SZ; i++){
		*dat = (*dat << 1) | ((buf[i] & DO_BIT) >> DO_BITNO);
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			/*CS:L*/
}
void write_rom( unsigned char adr, unsigned short dat )
{
	int i;
	unsigned char buf[(ST_SZ + OP_SZ + ADR_SZ + DAT_SZ)];
	
	for(i=0; i<ST_SZ; i++){
		buf[i] = 1;
	}
	for(i=0; i<OP_SZ; i++){
		buf[(i+ST_SZ)] = ((1 >> (OP_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<ADR_SZ; i++){
		buf[(i+ST_SZ+OP_SZ)] = ((adr >> (ADR_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<DAT_SZ; i++){
		buf[(i+ST_SZ+OP_SZ+ADR_SZ)] = ((dat >> (DAT_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ + DAT_SZ); i++){
		buf[i] = (buf[i] << DI_BITNO);
	}
	ROM_PORT = ROM_PORT | CS_BIT;				/*CS:H*/
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ + DAT_SZ); i++){
		ROM_PORT = ROM_PORT | buf[i];			/*DI:H*/
		ROM_PORT = ROM_PORT | SK_BIT;			/*SK:H*/
		ROM_PORT = ROM_PORT & ~DI_BIT;		/*DI:L*/
		ROM_PORT = ROM_PORT & ~SK_BIT;		/*SK:L*/
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			/*CS:L*/
	ROM_PORT = ROM_PORT | CS_BIT;				/*CS:H*/
	while((ROM_PORT & DO_BIT)==0){
		ROM_PORT = ROM_PORT | SK_BIT;			/*SK:H*/
		ROM_PORT = ROM_PORT & ~SK_BIT;		/*SK:L*/
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			/*CS:L*/
}
void eral_rom(void)
{
	int i;
	unsigned char buf[(ST_SZ + OP_SZ + ADR_SZ)];
	
	for(i=0; i<ST_SZ; i++){
		buf[i] = 1;
	}
	for(i=0; i<OP_SZ; i++){
		buf[(i+ST_SZ)] = ((0 >> (OP_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<ADR_SZ; i++){
		buf[(i+ST_SZ+OP_SZ)] = ((ERAL_ADR >> (ADR_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		buf[i] = (buf[i] << DI_BITNO);
	}
	ROM_PORT = ROM_PORT | CS_BIT;				/*CS:H*/
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		ROM_PORT = ROM_PORT | buf[i];			/*DI:H*/
		ROM_PORT = ROM_PORT | SK_BIT;			/*SK:H*/
		ROM_PORT = ROM_PORT & ~DI_BIT;		/*DI:L*/
		ROM_PORT = ROM_PORT & ~SK_BIT;		/*SK:L*/
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			/*CS:L*/
	ROM_PORT = ROM_PORT | CS_BIT;				/*CS:H*/
	while((ROM_PORT & DO_BIT)==0){
		ROM_PORT = ROM_PORT | SK_BIT;			/*SK:H*/
		ROM_PORT = ROM_PORT & ~SK_BIT;		/*SK:L*/
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			/*CS:L*/
}
